SystemOrganization addCategory: #'BackTalkNG-Kernel-Test'!
SystemOrganization addCategory: #'BackTalkNG-Kernel'!

Object subclass: #BTNGBinaryConstraint
	instanceVariableNames: 'variableA variableB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel'!

!BTNGBinaryConstraint methodsFor: 'filtering' stamp: 'Noury 4/3/2007 16:27'!
filter
	self subclassResponsibility ! !

!BTNGBinaryConstraint methodsFor: 'printing' stamp: 'Noury 4/3/2007 22:00'!
printOn: aStream
	aStream nextPutAll: self className;
		space;
		nextPut: $(.
	self variableA printOn: aStream.
	aStream nextPutAll: ', '.
	self variableB printOn: aStream.
	aStream nextPut: $)! !

!BTNGBinaryConstraint methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:42'!
reducedDomainA
	^self variableA reducedDomain! !

!BTNGBinaryConstraint methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:42'!
reducedDomainB
	^self variableB reducedDomain! !

!BTNGBinaryConstraint methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:18'!
variableA
	^variableA! !

!BTNGBinaryConstraint methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:52'!
variableA: anObject
	self variableA ifNotNil: [self variableA removeConstraint: self].
	variableA := anObject.
	self variableA addConstraint: self! !

!BTNGBinaryConstraint methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:19'!
variableB
	^variableB! !

!BTNGBinaryConstraint methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:52'!
variableB: anObject
	self variableB ifNotNil: [self variableB removeConstraint: self].
	variableB := anObject.
	self variableB addConstraint: self! !

!BTNGBinaryConstraint methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:54'!
variables
	^Set with: self variableA with: self variableB! !

BTNGBinaryConstraint subclass: #BTNGEqualityConstraintForTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel-Test'!

!BTNGEqualityConstraintForTest class methodsFor: 'instance creation' stamp: 'Noury 4/3/2007 16:20'!
on: var1 and: var2
	^self new
		variableA: var1;
		variableB: var2;
		yourself! !

!BTNGEqualityConstraintForTest methodsFor: 'filtering' stamp: 'Noury 4/3/2007 16:45'!
filter
	| intersection |
	intersection := self reducedDomainA intersection: self reducedDomainB.
	self variableA reducedDomain: intersection.
	self variableB reducedDomain: intersection
! !

Object subclass: #BTNGCSP
	instanceVariableNames: 'label variables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel'!

!BTNGCSP class methodsFor: 'instance creation' stamp: 'Noury 4/3/2007 17:28'!
label: aString variables: aCollection
	^self new
		label: aString variables: aCollection;
		yourself! !

!BTNGCSP methodsFor: 'accessing' stamp: 'Noury 4/4/2007 08:06'!
addVariable: aVariable
	self variables add: aVariable! !

!BTNGCSP methodsFor: 'accessing' stamp: 'Noury 4/3/2007 21:44'!
constraints
	| constraints |
	constraints := IdentitySet new.
	self variables do: [:var|
		constraints addAll: var constraints].
	^constraints! !

!BTNGCSP methodsFor: 'accessing' stamp: 'Noury 4/3/2007 17:25'!
label
	^label! !

!BTNGCSP methodsFor: 'accessing' stamp: 'Noury 4/3/2007 17:25'!
label: anObject
	label := anObject! !

!BTNGCSP methodsFor: 'initialize-release' stamp: 'Noury 4/3/2007 17:24'!
label: aString variables: aCollection
	self label: aString.
	self variables: aCollection asSet! !

!BTNGCSP methodsFor: 'accessing' stamp: 'Noury 4/4/2007 08:06'!
removeVariable: aVariable
	self variables remove: aVariable ifAbsent: []! !

!BTNGCSP methodsFor: 'accessing' stamp: 'Noury 4/4/2007 08:08'!
variables
	^variables! !

!BTNGCSP methodsFor: 'accessing' stamp: 'Noury 4/4/2007 08:06'!
variables: aCollection
	variables := aCollection asIdentitySet ! !

Object subclass: #BTNGSolver
	instanceVariableNames: 'csp solution currentVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel'!

!BTNGSolver class methodsFor: 'instance creation' stamp: 'Noury 4/3/2007 23:24'!
on: constraintSatisfactionProblem
	^self new
		csp: constraintSatisfactionProblem;
		yourself! !

!BTNGSolver methodsFor: 'solving' stamp: 'Noury 4/4/2007 07:51'!
chooseVariableAndValue
	"chooses a variable to instantiate and a value for this variable.
	Then performs the instantiation and triggers constraint propagation"
	currentVariable := self chooseAVariable.
	currentVariable nextValue.
	self propagateInstantiationOf: currentVariable! !

!BTNGSolver methodsFor: 'accessing' stamp: 'Noury 4/3/2007 22:19'!
csp
	^csp! !

!BTNGSolver methodsFor: 'accessing' stamp: 'Noury 4/3/2007 22:19'!
csp: anObject
	csp := anObject! !

!BTNGSolver methodsFor: 'accessing' stamp: 'Noury 4/3/2007 23:00'!
currentVariable
	^currentVariable! !

!BTNGSolver methodsFor: 'accessing' stamp: 'Noury 4/3/2007 23:00'!
currentVariable: anObject
	currentVariable := anObject! !

!BTNGSolver methodsFor: 'testing' stamp: 'Noury 4/3/2007 23:50'!
domainWipedOut
	self currentVariable ifNil: [^false].
	^self currentVariable domainWipedOut! !

!BTNGSolver methodsFor: 'solving' stamp: 'Noury 4/3/2007 22:22'!
firstSolution
	"goes forward until a solution is found"
	[self solutionFound] whileFalse: [self moveForward].
	^self solution! !

!BTNGSolver methodsFor: 'solving' stamp: 'Noury 4/4/2007 07:48'!
moveForward
	"goes forward until failure occurs, which triggers a backtracking"
	[self domainWipedOut] whileFalse: [self stepForward].
	self stepBackward! !

!BTNGSolver methodsFor: 'initialize-release' stamp: 'Noury 4/3/2007 23:29'!
reset
	self solution: IdentityDictionary new.
	self currentVariable: nil! !

!BTNGSolver methodsFor: 'accessing' stamp: 'Noury 4/3/2007 22:23'!
solution
	^solution! !

!BTNGSolver methodsFor: 'accessing' stamp: 'Noury 4/3/2007 22:24'!
solution: aDictionary
	solution := aDictionary! !

!BTNGSolver methodsFor: 'testing' stamp: 'Noury 4/3/2007 23:55'!
solutionFound
	^self solution size = self variables size! !

!BTNGSolver methodsFor: 'solving' stamp: 'Noury 4/4/2007 07:49'!
stepBackward
	"chooses a previously saved state of the problem and restores it"

	| context |
	context := self chooseAPreviousContext.
	self restoreContext: context! !

!BTNGSolver methodsFor: 'solving' stamp: 'Noury 4/4/2007 07:47'!
stepForward
	"saves the sate of the problem and chooses an instantiation to enforce"
	self saveContext.
	self chooseVariableAndValue! !

!BTNGSolver methodsFor: 'accessing' stamp: 'Noury 4/3/2007 23:49'!
variables
	^self csp variables! !

BTNGSolver subclass: #BTNGSolverForTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel-Test'!

Object subclass: #BTNGVariable
	instanceVariableNames: 'constraints label reducedDomain domain currentValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel'!

!BTNGVariable class methodsFor: 'instance creation' stamp: 'Noury 4/3/2007 17:28'!
label: aString domain: aCollection 
	^self new
		label: aString domain: aCollection;
		yourself! !

!BTNGVariable class methodsFor: 'instance creation' stamp: 'Noury 4/3/2007 15:46'!
label: aString from: lowerBound to: upperBound 
	^self
		label: aString
		domain: (lowerBound to: upperBound)
! !

!BTNGVariable methodsFor: 'constrainting' stamp: 'Noury 4/3/2007 16:53'!
addConstraint: aMaDcArConstraint 
	self constraints add: aMaDcArConstraint! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 15:35'!
constraints
	^ constraints! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 15:50'!
constraints: aCollection
	constraints := aCollection asSet! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 23:02'!
currentValue
	^currentValue! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 23:02'!
currentValue: anObject
	currentValue := anObject! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:13'!
domain
	^ domain! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 22:40'!
domain: aCollection 
	domain := aCollection asSet asArray.
	self reducedDomain: aCollection! !

!BTNGVariable methodsFor: 'testing' stamp: 'Noury 4/3/2007 23:02'!
domainWipedOut
	self reducedDomain ifEmpty: [^ true].
	^ self currentValue == self reducedDomain last! !

!BTNGVariable methodsFor: 'initialize' stamp: 'Noury 4/3/2007 23:06'!
initialize
	super initialize.
	self constraints: Set new! !

!BTNGVariable methodsFor: 'testing' stamp: 'Noury 4/3/2007 23:34'!
isInstantiated
	^ self currentValue ~~ nil! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 15:35'!
label
	^ label! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 15:35'!
label: aByteString 
	label := aByteString ! !

!BTNGVariable methodsFor: 'initialize' stamp: 'Noury 4/3/2007 16:13'!
label: aString domain: aCollection 
	self label: aString.
	self domain: aCollection! !

!BTNGVariable methodsFor: 'enumerating' stamp: 'Noury 4/3/2007 23:04'!
nextValue
	| nextValue |
	nextValue := self currentValue 
			ifNil: [self reducedDomain first]
			ifNotNil: [self reducedDomain after: self currentValue].
	self currentValue: nextValue.
	^nextValue! !

!BTNGVariable methodsFor: 'printing' stamp: 'Noury 4/3/2007 21:53'!
printOn: aStream
	aStream nextPutAll: self label! !

!BTNGVariable methodsFor: 'filtering' stamp: 'Noury 4/3/2007 16:35'!
reduceToReject: aBlock
	| newReducedDomain |
	newReducedDomain :=  self reducedDomain reject: aBlock.
	self reducedDomain: newReducedDomain! !

!BTNGVariable methodsFor: 'filtering' stamp: 'Noury 4/3/2007 16:34'!
reduceToSelect: aBlock
	| newReducedDomain |
	newReducedDomain :=  self reducedDomain select: aBlock.
	self reducedDomain: newReducedDomain! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 16:13'!
reducedDomain
	^ reducedDomain! !

!BTNGVariable methodsFor: 'accessing' stamp: 'Noury 4/3/2007 22:40'!
reducedDomain: aCollection 
	reducedDomain := aCollection asSet asOrderedCollection ! !

!BTNGVariable methodsFor: 'constrainting' stamp: 'Noury 4/3/2007 16:58'!
removeConstraint: aMaDcArConstraint 
	self constraints remove: aMaDcArConstraint ifAbsent: []! !

!BTNGVariable methodsFor: 'initialize' stamp: 'Noury 4/3/2007 23:02'!
reset
	self reducedDomain: self domain.
	self currentValue: nil! !

TestCase subclass: #BTNGBinaryConstraintTest
	instanceVariableNames: 'variable1 variable2 constraint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel-Test'!

!BTNGBinaryConstraintTest methodsFor: 'setUp-tearDown' stamp: 'Noury 4/3/2007 17:05'!
setUp
	variable1 := BTNGVariable 
				label: 'v1'
				from: 0
				to: 10.
	variable2 := BTNGVariable 
				label: 'v2'
				from: 2
				to: 12.
	constraint := BTNGEqualityConstraintForTest on: variable1 and: variable2! !

!BTNGBinaryConstraintTest methodsFor: 'running' stamp: 'Noury 4/3/2007 22:56'!
testFiltering
	| expectedReducedDomain |
	constraint filter.
	expectedReducedDomain := (2 to: 10) asSet.
	self assert: variable1 reducedDomain asSet = expectedReducedDomain.
	self assert: variable2 reducedDomain asSet = expectedReducedDomain.! !

!BTNGBinaryConstraintTest methodsFor: 'running' stamp: 'Noury 4/3/2007 21:59'!
testPrinting
	self assert: constraint printString = 'BTNGEqualityConstraintForTest (v1, v2)'! !

!BTNGBinaryConstraintTest methodsFor: 'running' stamp: 'Noury 4/3/2007 17:05'!
testReferencesAfterVariableRemoval
	| expectedConstraints expectedVariables newVariable |
	newVariable := BTNGVariable 
				label: 'x'
				from: 1
				to: 2.
	constraint variableA: newVariable.
	expectedConstraints := Set with: constraint.
	expectedVariables := Set with: variable2 with: newVariable.
	self assert: variable1 constraints isEmpty.
	self assert: variable2 constraints = expectedConstraints.
	self assert: constraint variables = expectedVariables! !

!BTNGBinaryConstraintTest methodsFor: 'running' stamp: 'Noury 4/3/2007 16:57'!
testReferencesOnFromVariables
	| expectedConstraints expectedVariables |
	expectedConstraints := {  constraint} asSet.
	expectedVariables := {  variable1. variable2} asSet.
	self assert: variable1 constraints = expectedConstraints.
	self assert: variable2 constraints = expectedConstraints.
	self assert: constraint variables = expectedVariables! !

BTNGBinaryConstraintTest subclass: #BTNGCSPTest
	instanceVariableNames: 'csp variable3 variable4 constraint2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel-Test'!

!BTNGCSPTest methodsFor: 'setUp-tearDown' stamp: 'Noury 4/3/2007 22:07'!
setUp
	super setUp.
	variable3 := BTNGVariable 
				label: 'v3'
				from: 5
				to: 8.
	variable4 := BTNGVariable 
				label: 'v4'
				from: 3
				to: 6.
	constraint2 := BTNGEqualityConstraintForTest on: variable3 and: variable4.
	csp := BTNGCSP label: 'cspTest'
				variables: {  variable1. variable2}! !

!BTNGCSPTest methodsFor: 'running' stamp: 'Noury 4/4/2007 07:55'!
testInitialization
	| expectedVariables expectedConstraints |
	expectedVariables := IdentitySet with: variable1 with: variable2.
	self assert: csp variables asIdentitySet = expectedVariables.
	expectedConstraints := IdentitySet with: constraint.
	self assert: csp constraints = expectedConstraints
	
! !

!BTNGCSPTest methodsFor: 'running' stamp: 'Noury 4/4/2007 08:08'!
testUnicityOfVariablesOnMultipleAdditions
	| expectedVariables |
	csp variables add: variable2.
	csp addVariable: variable2.
	expectedVariables := IdentitySet with: variable1 with: variable2.
	self assert: csp variables size = expectedVariables size.
	self assert: csp variables asIdentitySet = expectedVariables! !

!BTNGCSPTest methodsFor: 'running' stamp: 'Noury 4/4/2007 07:57'!
testUnicityOfVariablesOnSettingTheWholeCollection
	| expectedVariables |
	csp variables: {variable2. variable1. variable2. variable2. variable1}.
	expectedVariables := IdentitySet with: variable1 with: variable2.
	self assert: csp variables size = expectedVariables size.
	self assert: csp variables asIdentitySet = expectedVariables! !

!BTNGCSPTest methodsFor: 'running' stamp: 'Noury 4/4/2007 08:08'!
testVariableAddition
	| expectedVariables expectedConstraints |
	csp addVariable: variable3.
	csp variables add: variable4.
	expectedVariables := IdentitySet 
				with: variable1
				with: variable2
				with: variable3
				with: variable4.
	self assert: csp variables asIdentitySet = expectedVariables.
	expectedConstraints := IdentitySet with: constraint with: constraint2.
	self assert: csp constraints = expectedConstraints! !

!BTNGCSPTest methodsFor: 'running' stamp: 'Noury 4/4/2007 08:11'!
testVariableRemoval
	| expectedVariables expectedConstraints |
	csp removeVariable: variable2.
	expectedVariables := IdentitySet 
				with: variable1.
	self assert: csp variables asIdentitySet = expectedVariables.
	expectedConstraints := IdentitySet with: constraint.
	self assert: csp constraints = expectedConstraints.
	self shouldnt: [csp removeVariable: variable2] raise: Exception! !

BTNGCSPTest subclass: #BTNGSolverTest
	instanceVariableNames: 'solver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel-Test'!

!BTNGSolverTest methodsFor: 'setUp-tearDown' stamp: 'Noury 4/3/2007 23:23'!
setUp
	super setUp.
	solver := BTNGSolverForTest on: csp! !

!BTNGSolverTest methodsFor: 'running' stamp: 'Noury 4/3/2007 23:32'!
testFirstSolution
	| solution value1 value2 value3 value4 |
	solution := solver firstSolution.
	self assert: solver solutionFound.
	value1 := solution at: variable1.
	value2 := solution at: variable2.
	self assert: value1 = value2.
	value3 := solution at: variable3.
	value4 := solution at: variable4.
	self assert: value3 = value4.
! !

TestCase subclass: #BTNGVariableTest
	instanceVariableNames: 'variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackTalkNG-Kernel-Test'!

!BTNGVariableTest methodsFor: 'setUp-tearDown' stamp: 'Noury 4/3/2007 17:05'!
setUp
	variable := BTNGVariable 
				label: 'x'
				from: 1
				to: 3! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 22:56'!
testDomainChange
	| expectedDomain |
	expectedDomain := (1 to: 5) asSet.
	variable reducedDomain: (Set with: 0).
	variable domain: expectedDomain.
	self assert: variable domain asSet = expectedDomain.
	self assert: variable reducedDomain asSet = expectedDomain.
	self deny: variable domain == variable reducedDomain! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 22:54'!
testEnumeration
	| expectedValues values |
	expectedValues := Set with: 1 with: 2 with: 3.
	values := Set new.
	3 timesRepeat: [values add: variable nextValue].
	self assert: values = expectedValues.
	self assert: variable domainWipedOut ! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 23:39'!
testInitialDomain
	| expectedDomain |
	expectedDomain := Set with: 1 with: 2 with: 3.
	self assert: variable domain asSet = expectedDomain.
	self assert: variable reducedDomain asSet = expectedDomain.
	self deny: variable domain == variable reducedDomain.
! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 21:52'!
testPrinting
	self assert: variable printString = variable label! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 22:57'!
testReduceToReject
	variable reduceToReject: [:value | value even].
	self assert: variable reducedDomain asSet = #(1 3) asSet! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 22:57'!
testReduceToSelect
	variable reduceToSelect: [:value | value even].
	self assert: variable reducedDomain asSet = #(2) asSet! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 22:57'!
testReducedDomainWriting
	| providedDomain |
	providedDomain := Set with: 4 with: 5.
	variable reducedDomain: providedDomain.
	self assert: variable reducedDomain asSet = providedDomain.
	self deny: variable reducedDomain asSet == providedDomain.! !

!BTNGVariableTest methodsFor: 'running' stamp: 'Noury 4/3/2007 23:42'!
testUnicityOfDomainElements
	| expectedDomain |
	expectedDomain := (1 to: 3) asSet.
	variable domain: {1. 2. 3. 2. 3}.
	self assert: variable domain size = expectedDomain size.
	self assert: variable domain asSet = expectedDomain! !
